### Hierarchy

- StateBuilder

## Index

### Constructors

- constructor

### Properties

- builders
- matcher

### Methods

- build
- builder
- name
- parentName

## Constructors

- new StateBuilder(matcher: StateMatcher, urlMatcherFactory: UrlMatcherFactory): StateBuilder

- #### Parameters

  - ##### matcher StateMatcher

  - ##### urlMatcherFactory UrlMatcherFactory

  #### Returns StateBuilder

  - Defined in state/stateBuilder.ts:218

## Properties

builders: Builders

An object that contains all the BuilderFunctions registered, key'd by the name of the State property they build

An object that contains all the BuilderFunctions registered, key'd by the name of the State property they build

- Defined in state/stateBuilder.ts:218

matcher: StateMatcher

- Defined in state/stateBuilder.ts:220

## Methods

- build(state: StateObject): StateObject

- Builds all of the properties on an essentially blank State object, returning a State object which has all its properties and API built.

- Builds all of the properties on an essentially blank State object, returning a State object which has all its properties and API built.

  #### Parameters

  - ##### state StateObject

    :

    an uninitialized State object

  #### Returns StateObject

  :

  the built State object

  - Defined in state/stateBuilder.ts:281

- builder(name: string, fn: BuilderFunction): Function | function | function[]

- Registers a BuilderFunction for a specific StateObject property (e.g., `parent`, `url`, or `path`). More than one BuilderFunction can be registered for a given property.

- Registers a BuilderFunction for a specific StateObject property (e.g., `parent`, `url`, or `path`). More than one BuilderFunction can be registered for a given property.

  The BuilderFunction(s) will be used to define the property on any subsequently built StateObject objects.

  #### Parameters

  - ##### name string

    :

    The name of the State property being registered for.

  - ##### fn BuilderFunction

    :

    The BuilderFunction which will be used to build the State property

  #### Returns Function | function | function[]

  :

  a function which deregisters the BuilderFunction

  - Defined in state/stateBuilder.ts:262

- name(state: StateObject): string

- #### Parameters

  - ##### state StateObject

  #### Returns string

  - Defined in state/stateBuilder.ts:320

- parentName(state: StateObject): string

- #### Parameters

  - ##### state StateObject

  #### Returns string

  - Defined in state/stateBuilder.ts:297

Generated using TypeDoc